#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire700four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire700four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four7004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four7004xi = {
                1:'105x-25y691z',
                2:'106x-675y150z',
                3:'111x-145y675z',
                4:'112x-20y690z',
                5:'114x-278y631z',
                6:'120x-15y689z',
                7:'123x-144y673z',
                8:'128x-9y688z',
                9:'131x-277y628z',
                10:'135x-142y671z',
                11:'135x-3y686z',
                12:'142x-670y144z',
                13:'147x-140y669z',
                14:'149x-276y625z',
                15:'159x-136y667z',
                16:'166x-273y622z',
                17:'171x-132y665z',
                18:'177x-663y137z',
                19:'184x-126y663z',
                20:'184x-269y619z',
                21:'186x-395y546z',
                22:'196x-120y661z',
                23:'201x-264y616z',
                24:'207x-112y658z',
                25:'209x-389y542z',
                26:'212x-654y130z',
                27:'219x-104y656z',
                28:'219x-257y612z',
                29:'230x-95y653z',
                30:'232x-382y537z',
                31:'236x-250y609z',
                32:'241x-85y651z',
                33:'246x-643y123z',
                34:'251x-74y648z',
                35:'253x-242y605z',
                36:'255x-374y533z',
                37:'258x-481y437z',
                38:'261x-62y646z',
                39:'270x-232y602z',
                40:'271x-50y643z',
                41:'278x-365y528z',
                42:'279x-36y640z',
                43:'280x-630y116z',
                44:'285x-470y432z',
                45:'287x-221y598z',
                46:'287x-22y637z',
                47:'294x-7y634z',
                48:'300x-353y524z',
                49:'303x-209y594z',
                50:'312x-458y426z',
                51:'313x-616y109z',
                52:'319x-196y591z',
                53:'321x-341y519z',
                54:'334x-182y587z',
                55:'338x-444y421z',
                56:'343x-327y514z',
                57:'346x-599y102z',
                58:'348x-167y583z',
                59:'35x-679y164z',
                60:'362x-150y579z',
                61:'363x-312y509z',
                62:'363x-429y415z',
                63:'374x-133y575z',
                64:'377x-581y95z',
                65:'383x-296y505z',
                66:'386x-115y571z',
                67:'388x-413y410z',
                68:'397x-96y567z',
                69:'402x-278y500z',
                70:'408x-561y88z',
                71:'408x-76y563z',
                72:'412x-395y404z',
                73:'417x-55y559z',
                74:'41x-31y698z',
                75:'420x-259y495z',
                76:'424x-34y555z',
                77:'431x-12y550z',
                78:'435x-375y398z',
                79:'437x-540y81z',
                80:'438x-239y490z',
                81:'454x-218y485z',
                82:'458x-354y392z',
                83:'465x-517y74z',
                84:'469x-196y480z',
                85:'479x-332y387z',
                86:'47x-134y685z',
                87:'484x-173y475z',
                88:'48x-33y697z',
                89:'492x-492y67z',
                90:'496x-149y469z',
                91:'499x-308y381z',
                92:'508x-124y464z',
                93:'518x-284y375z',
                94:'518x-466y60z',
                95:'518x-98y459z',
                96:'527x-71y454z',
                97:'535x-258y369z',
                98:'535x-44y448z',
                99:'541x-16y443z',
                100:'542x-439y53z',
                101:'551x-231y363z',
                102:'565x-410y47z',
                103:'56x-34y696z',
                104:'57x-137y683z',
                105:'586x-380y40z',
                106:'605x-349y33z',
                107:'623x-317y26z',
                108:'639x-284y19z',
                109:'647x-232y408z',
                110:'64x-34y696z',
                111:'653x-250y12z',
                112:'665x-216y5z',
                113:'67x-140y682z',
                114:'71x-678y157z',
                115:'72x-34y695z',
                116:'77x-143y680z',
                117:'80x-33y694z',
                118:'88x-144y679z',
                119:'88x-31y693z',
                120:'96x-28y692z',
                121:'99x-145y677z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire700four4xi" usage = "target function for charge7004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire700four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE700FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE700FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE700FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE700FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE700FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four7004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE700FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE700FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE700FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four7004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four7004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE700FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE700FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE700FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire700four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                   